defProperty('txnode', 'node21-1.grid.orbit-lab.org', "Console connected to the transmit node")
#defProperty('addr', 'addr=10.10.23.3', "IP address of USRP")
defProperty('rate', '5e6', "Sampling rate")
#defProperty('freq', '5030000000', "Center frequency")
defProperty('t_on', '5', "ON duration (number of slots)")
defProperty('t_off', '7', "OFF duration (number of slots)")
#defProperty('t_gran', '0.5', "Time granularity (in seconds)")
defProperty('runtime', 50, "Run time (s)")

defApplication('test:app:genericofdm', 'generic_ofdm.py') { |a|
    a.version(2, 0, 4)
    a.shortDescription = ""
    a.description = ""
    a.path = "export LC_ALL=C;/root/SC2/generic_ofdm.py"
    a.defProperty('addr', "IP address of USRP", '--addr',
                  {:dynamic => false, :type => :string})
    a.defProperty('freq', "center frequency in Hz", '-f',
                  {:dynamic => false, :type => :string})
    a.defProperty('gain', "Transmit gain in dB", '--gain', 
                  {:dynamic => false, :type => :string})
    a.defProperty('rate', "specify sampling rate", '--rate',
                  {:dynamic => false, :type => :string})
    a.defProperty('t_gran', "specify size of time slot in seconds", '--t-gran',
                  {:dynamic => false, :type => :string})
    a.defProperty('t_on', "specify ON duration (number of slots)", '--t-on',
                  {:dynamic => false, :type => :string})
    a.defProperty('t_off', "specify OFF duration (number of slots)", '--t-off',
                  {:dynamic => false, :type => :string})
}

defGroup('tx_node0', property.txnode) { |n|
    n.addApplication('test:app:genericofdm') { |app|
        app.setProperty('addr','addr=10.10.23.1')
        app.setProperty('freq', '5040000000')
        app.setProperty('rate',property.rate)
        app.setProperty('gain','20')
        app.setProperty('t_gran','0.4')
        app.setProperty('t_on',property.t_on)
        app.setProperty('t_off',property.t_off)
    }
}

defGroup('tx_node1', property.txnode) { |n|
    n.addApplication('test:app:genericofdm') { |app|
        app.setProperty('addr','addr=10.10.23.2')
        app.setProperty('freq', '5050000000')
        app.setProperty('rate',property.rate)
        app.setProperty('gain','20')
        app.setProperty('t_gran','0.5')
        app.setProperty('t_on',property.t_on)
        app.setProperty('t_off',property.t_off)
    }
}

onEvent(:ALL_UP_AND_INSTALLED) { |event|
    info "Give machines some time to warm up :-)" 
    wait 2
    info "Starting the transmitter"
    allGroups.startApplications
    info "Runing for #{property.runtime} seconds..."
    wait property.runtime
    info "Done! Stop eveything"
    allGroups.stopApplications
    Experiment.done
}

